﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using System.Collections.ObjectModel;
using System.Collections;

namespace TreeViewSelectionChanged
{
	/// <summary>
	/// Interaction logic for Window1.xaml
	/// </summary>
	public partial class Window1 : Window
	{
		public Window1()
		{
			InitializeComponent();
			this.treeView.ItemsSource = this.GenerateData();
		}


		private ObservableCollection<Company> GenerateData()
		{
			ObservableCollection<Company> result = new ObservableCollection<Company>();

			for (int i = 0; i < 2; i++)
			{
				Company c = new Company()
				{
					Name = String.Format("Company {0}", i)
				};

				for (int j = 0; j < 2; j++)
				{
					Department d = new Department()
					{
						Name = String.Format("Department {0}", j)
					};

					for (int k = 0; k < 2; k++)
					{
						Employee e = new Employee()
						{
							Name = String.Format("Employee {0}", k)
						};
						d.Employees.Add(e);
					}
					c.Departments.Add(d);
				}
				result.Add(c);
			}
			return result;
		}
		
		private void radTreeView_SelectionChanged(object sender, SelectionChangedEventArgs e)
		{
			RadTreeViewItem selectedContainer = treeView.SelectedContainer; 
			
			RadTreeViewItem nextItem = selectedContainer.NextItem; 
			RadTreeViewItem previousItem = selectedContainer.PreviousItem; 
			RadTreeViewItem parentItem  = selectedContainer.ParentItem;
			IEnumerable childCollection = selectedContainer.ItemsSource; 

			if (selectedContainer != null) current.Text = selectedContainer.ToString(); 
			else current.Text = "";
			if (nextItem != null) next.Text = nextItem.ToString();
			else next.Text = "";
			if (previousItem != null) previous.Text = previousItem.ToString();
			else previous.Text = "";
			if (parentItem != null) parent.Text = parentItem.ToString();
			else parent.Text = "";
			if (childCollection != null) children.ItemsSource = childCollection;
			else children.ItemsSource = null;
		}
	}
}
